<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Fax ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Fax extends AbstractStructArrayBase
{
    /**
     * The Fax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Fax[]
     */
    public $Fax;
    /**
     * Constructor method for ArrayOfJP_Fax
     * @uses ArrayOfJP_Fax::setFax()
     * @param \StructType\JP_Fax[] $fax
     */
    public function __construct(array $fax = array())
    {
        $this
            ->setFax($fax);
    }
    /**
     * Get Fax value
     * @return \StructType\JP_Fax[]|null
     */
    public function getFax()
    {
        return $this->Fax;
    }
    /**
     * This method is responsible for validating the values passed to the setFax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFaxForArrayConstraintsFromSetFax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FaxFaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FaxFaxItem instanceof \StructType\JP_Fax) {
                $invalidValues[] = is_object($arrayOfJP_FaxFaxItem) ? get_class($arrayOfJP_FaxFaxItem) : sprintf('%s(%s)', gettype($arrayOfJP_FaxFaxItem), var_export($arrayOfJP_FaxFaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Fax property can only contain items of type \StructType\JP_Fax, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Fax value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Fax[] $fax
     * @return \ArrayType\ArrayOfJP_Fax
     */
    public function setFax(array $fax = array())
    {
        // validation for constraint: array
        if ('' !== ($faxArrayErrorMessage = self::validateFaxForArrayConstraintsFromSetFax($fax))) {
            throw new \InvalidArgumentException($faxArrayErrorMessage, __LINE__);
        }
        $this->Fax = $fax;
        return $this;
    }
    /**
     * Add item to Fax value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Fax $item
     * @return \ArrayType\ArrayOfJP_Fax
     */
    public function addToFax(\StructType\JP_Fax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Fax) {
            throw new \InvalidArgumentException(sprintf('The Fax property can only contain items of type \StructType\JP_Fax, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Fax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Fax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Fax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Fax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Fax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Fax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Fax
     */
    public function getAttributeName()
    {
        return 'Fax';
    }
}
